{******************************************************************************}
{                       CnPack For Delphi/C++Builder                           }
{                     йԼĿԴ                         }
{                   (C)Copyright 2001-2022 CnPack                        }
{                   ------------------------------------                       }
{                                                                              }
{            ǿԴ CnPack ķЭ        }
{        ĺ·һ                                                }
{                                                                              }
{            һĿϣãûκεû        }
{        ʺضĿĶĵϸ CnPack Э顣        }
{                                                                              }
{            ӦѾͿһյһ CnPack Эĸ        }
{        ûУɷǵվ                                            }
{                                                                              }
{            վַhttp://www.cnpack.org                                   }
{            ʼmaster@cnpack.org                                       }
{                                                                              }
{******************************************************************************}

unit CnLangReg;
{* |<PRE>
================================================================================
* ƣCnPack 
* ԪƣעᵥԪ
* ԪߣCnPack Х (liuxiao@cnpack.org)
*     עõԪʵ˶ͱ༭ע
* ƽ̨PWin2000 + Delphi 5.0
* ݲԣPWin9X/2000/XP + Delphi 5/6/7
*   õԪеַϱػʽ
* ޸ļ¼2003.08.20 V1.0
*               Ԫʵֹ
================================================================================
|</PRE>}

interface

{$I CnPack.inc}

uses
  {$IFDEF COMPILER6_UP}
  DesignIntf, DesignEditors,
  {$ELSE}
  DsgnIntf,
  {$ENDIF}
  SysUtils, Classes,
  CnLangCollection, CnLangConsts, CnLangMgr, CnLangStorage, CnLangTranslator,
  CnLangEditors, CnTransEditor, CnHashLangStorage, CnIniLangFileStorage;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('CnMutiLang', [TCnLangManager, TCnLangTranslator,
    TCnHashLangFileStorage, TCnIniLangFileStorage]);
  RegisterPropertyEditor(TypeInfo(LongWord), TCnLanguageItem, 'LanguageID',
    TCnLanguageItemProperty);
  RegisterPropertyEditor(TypeInfo(Integer), TCnLangManager, 'CurrentLanguageIndex',
    TCnLangManagerProperty);
  RegisterPropertyEditor(TypeInfo(WideString), TCnCustomLangFileStorage, 'LanguagePath',
    TCnLanguagePathProperty);
  RegisterComponentEditor(TCnLangTranslator, TCnTranslatorEditor);
{$IFDEF DELPHI}
  RegisterComponentEditor(TCnCustomLangStorage, TCnStorageEditor);
{$ENDIF}
{$IFDEF COMPILER6_UP}
  RegisterSelectionEditor(TComponent, TCnLangDesignerEditor);
{$ENDIF}
end;

end.
